/*
    Copyright (C) 1999 by  XCIN TEAM

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/      

#ifndef	_IMODULE_H
#define	_IMODULE_H

#include "module.h"

/*---------------------------------------------------------------------------

	General module definition (Internal).

---------------------------------------------------------------------------*/

typedef struct imodule_s  imodule_t;
struct imodule_s {
    void *modp;
    char *name;
    char *version;
    char *comments;
    char *objname;
    enum mtype module_type;

    void *conf;
    int (*init) (void *conf, char *objname, oxim_rc_t *xc);
    int (*xim_init) (void *conf, inpinfo_t *inpinfo);
    unsigned int (*xim_end) (void *conf, inpinfo_t *inpinfo);
    int (*switch_in) (void *conf, inpinfo_t *inpinfo);
    int (*switch_out) (void *conf, inpinfo_t *inpinfo);
    unsigned int (*keystroke) (void *conf, inpinfo_t *inpinfo, keyinfo_t *keyinfo);
    int (*show_keystroke) (void *conf, simdinfo_t *simdinfo);
    int (*terminate) (void *conf);
};

typedef struct
{
    int  key;	   /* Hot key */
    char *inpname; /* 輸入法名稱(顯示用) */
    char *modname; /* 模組名稱 */
    char *objname;
    imodule_t *imodp;
} im_t;

typedef char numlist_t;

extern imodule_t *OXIM_IMGet(int idx, oxim_rc_t *xrc);
extern imodule_t *OXIM_IMGetNext(int idx, int *idx_ret, oxim_rc_t *xrc);
extern imodule_t *OXIM_IMGetPrev(int idx, int *idx_ret, oxim_rc_t *xrc);
extern numlist_t *IM_get_numlist(void);
extern imodule_t *OXIM_IMSearch(char *objname, int *idx_ret, oxim_rc_t *xrc);

/* 釋放全部的輸入法 */
extern void OXIM_IMFreeAll(void);
/* 取得輸入法總數 */
extern int OXIM_MaxIM(void);
/* 以索引取得輸入法顯示名稱與 key*/
extern im_t *OXIM_GetIMByIndex(int idx);
/* 以按鍵碼(0-9)取得輸入法索引值(-1:表示無按鍵指定) */
extern int OXIM_GetIMIdxByKey(int key);
/* 讀取使用者與系統自訂之輸入法表格與輸入法模組 */
extern void OMIM_LoadIMList(oxim_rc_t *xrc);

#endif
